#
# Conditional build:
%bcond_with	systemlibs	# use system libraries instead of modified ones
#				  (modified can give little better results)
# NOTE:
# - to use system libs, read desc from homepage: http://pmt.sourceforge.net/pngcrush/
# - bundled zlib-1.2.3 differs from zlib-1.2.3 that it defines TOO_FAR
#   32767 instead of 4096
# - libpng diffs (this is bad?):
#diff -ur ../libpng-1.2.8/pngrutil.c ./pngrutil.c
#--- ../libpng-1.2.8/pngrutil.c    2006-03-21 16:12:37.000000000 +0200
#+++ ./pngrutil.c    2005-02-28 15:55:20.000000000 +0200
#@@ -1056,12 +1056,6 @@
#    prefix_length = profile - chunkdata;
#    chunkdata = png_decompress_chunk(png_ptr, compression_type, chunkdata,
#                                     slength, prefix_length, &data_length);
#-   if(chunkdata)
#-       png_set_iCCP(png_ptr, info_ptr, chunkdata, compression_type,
#-               chunkdata + prefix_length, data_length);
#-   else
#-       png_set_iCCP(png_ptr, info_ptr, chunkdata, compression_type,
#-               0x00, prefix_length);
#
#    profile_length = data_length - prefix_length;
#
Summary:	Optimizer for png files
Summary(pl.UTF-8):	Optymalizator plików png
Summary(pt_BR.UTF-8):	Utilitário para compressão de pngs
Name:		pngcrush
Version:	1.8.13
Release:	1
License:	BSD-like (see LICENSE)
Group:		Applications/Graphics
Source0:	http://downloads.sourceforge.net/pmt/%{name}-%{version}.tar.xz
# Source0-md5:	2eeb072fcb56dcc4f7ccc35bd4238bd3
Patch0:		%{name}-ptrdiff.patch
URL:		http://pmt.sourceforge.net/pngcrush/
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
%if %{with systemlibs}
BuildRequires:	libpng-devel
BuildRequires:	pkgconfig
BuildRequires:	zlib-devel
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This program reads in a PNG image, and writes it out again, with the
optimum filter_method and zlib_level. It uses brute force (trying
filter_method none, and libpng adaptive filtering, with compression
levels 3 and 9). It does the most time-consuming method last in case
it turns out to be the best.

%description -l pl.UTF-8
Ten program wczytuje obrazek PNG i zapisuje go ponownie z optymalnymi
parametrami filter_method i zlib_level. Używa metody brute force
(próbuje filter_method none oraz adaptacyjnego filtrowania libpng ze
stopniami kompresji 3 i 9).

%description -l pt_BR.UTF-8
O pngcrush é um otimizador para arquivos PNG (Portable Network
Graphics). Ele pode comprimir os arquivos em até 40%, sem perdas.

%prep
%setup -q
%patch0 -p1

# create some real documentation
# NOTE: remember to check these on upgrade!
sed -ne '1,/*\//p' pngcrush.c | cut -b 4- > README
sed -ne '/\/\* To do/,/*\/$/p;/PNG_INTERNAL/q' pngcrush.c | cut -b 4- > TODO
sed -ne '/* COPYRIGHT/,/*\/$/p;' pngcrush.c | cut -b 4- > LICENSE

%build
%{__make} %{?with_systemlibs:-f Makefile-nolib} \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -std=c90 -Wall" \
	OPTIONS="%{rpmcppflags}" \
	LD="%{__cc}" \
	LDFLAGS="%{rpmldflags}" \
%if %{with systemlibs}
	PNGINC=$(pkg-config --variable=includedir libpng) \
	PNGLIB=%{_libdir} \
	ZINC=%{_includedir} \
	ZLIB=%{_libdir}
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_bindir}

cp -p pngcrush $RPM_BUILD_ROOT%{_bindir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE README TODO ChangeLog.html
%attr(755,root,root) %{_bindir}/pngcrush
%changelog
* Mon May 28 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/pngcrush.git;a=log;h=master

* Mon May 28 2018 Jakub Bogusz <qboosh@pld-linux.org> ef461a7
- updated to 1.8.13
- added ptrdiff patch (fixes internal zlib build with Z_SOLO)

* Sat Jan 16 2016 Łukasz Kieś <kiesiu@pld-linux.org> 9eef953
- updated to 1.7.92

* Fri Feb 13 2015 Łukasz Kieś <kiesiu@pld-linux.org> bde8551
- updated to 1.7.83

* Mon Jul 02 2012 Jakub Bogusz <qboosh@pld-linux.org> b27f626
- updated to 1.7.30 (based on zlib 1.2.7/libpng 1.5.10)

* Mon Feb 21 2011 Elan Ruusamäe <glen@pld-linux.org> 9182092
- up to 1.7.13

* Sun Jul 05 2009 Artur Frysiak <artur@frysiak.net> f9f965f
- updated to 1.6.19

* Mon May 12 2008 Kacper Kornet <draenog@pld-linux.org> d833b02
- 1.6.5 (CVE-2008-1382)
- fix of TODO
- generation of LICENSE
- use correct linker

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> b3fd32b
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 212dd0f
- converted to UTF-8

* Fri Apr 21 2006 Jan Rękorajski <baggins@pld-linux.org> 479fd5d
- orphaned, outdated

* Tue Mar 21 2006 Elan Ruusamäe <glen@pld-linux.org> 43fdff6
- up to 1.6.2, fixes CVE-2005-1849
- rel 2 (1 reserved for Ra)
- STBR to Ac?

* Tue Apr 27 2004 Jakub Bogusz <qboosh@pld-linux.org> 1b62470
- release 3

* Tue Apr 27 2004 Jakub Bogusz <qboosh@pld-linux.org> 8be9d70
- License is BSD-like not GPL

* Mon Apr 26 2004 Adam Gołębiowski <adamg@pld-linux.org> a57e980
- release 2 for Ac (1 is for Ra)

* Wed May 28 2003 Michal Moskal <michal@moskal.me> 7e2ccf6
- massive attack: source-md5

* Sun May 25 2003 misi3k <misi3k@pld-linux.org> 31a3f7e
- massive attack s/pld.org.pl/pld-linux.org/

* Fri Mar 14 2003 Jakub Bogusz <qboosh@pld-linux.org> 6d6d505
- fixed bcond, added note about line numbers

* Thu Mar 13 2003 wolf <wolf@pld-linux.org> 896bd25
- updating is not just bumping %%version, kloczek

* Thu Mar 13 2003 kloczek <kloczek@pld-linux.org> 4120cc8
- updated to 1.5.10: bug fixes,
- added system-libs patch for linking pngcrush with system avalaible libpng an libz
  (based on patch from Conectiva).

* Thu Mar 13 2003 kloczek <kloczek@pld-linux.org> bc8f036
- use system avalaible shared libpng and libz (patch based one version from Conectiva).

